function GetFile( title, filename, kakucho )
{
	var	input_file, temp, warning_flag = ON;
	var	i, ele[3];

	if( MACHINE != "WINDOWS" )
	{
		DlogOpen( title, 1 );
		DlogString( 0, "t@C", filename, 40 );
		i = DlogWait();
		if( i == 0 )
			return FALSE;
		input_file = MakeFile( DlogAnswer( 0 ), kakucho );
	}
	else
	{
		if( toupper( kakucho ) == "SUF" )
			temp = "`t@C(*.SUF)";
		else if( toupper( kakucho ) == "ATR" )
			temp = "Agr[gt@C(*.ATR)";
		else if( toupper( kakucho ) == "FSC" )
			temp = "JfUCf[^(*.FSC)";
		else if( toupper( kakucho ) == "INI" )
			temp = "ݒt@C(*.INI)";
		else
			temp = "ׂẴt@C(*.*)";
		if( filename == "" )
			input_file = DlogFileOpen( title, "", temp );
		else
			input_file = DlogFileOpen( title, filename, temp );
	}
	if( input_file == "" )
	{
		Warning();
		return FALSE;
	}
	return input_file;
}

//
//	`Z[u֐
//
function _SaveSuf( filename, savefile_org, obj_flag )
{
	var	i, num;
	var	flag = OFF;
	var	temp1, temp2;
	var	ele[3], savefile;

	temp2 = fullpath(MakeFile( filename, ".suf"));
	savefile = fullpath( MakeFile( savefile_org, ".suf" ));
	num = Objects();
	for( i = 0; i< num; i++ )
	{
		temp1 = toupper( fullpath(MakeFile( ObjFile(i), ".suf")));
		if( temp1 == toupper(temp2))
		{
			SelectObj( i, TRUE, SELECT_UPDATE );
			ObjFile( i , savefile);
			if( obj_flag == TRUE )
			{
				Bunkai( savefile_org, ele );
				ObjName( i, ele[1] );
			}
			if( SelectPolygons() != 0 )
			{
				if( flag == OFF )
				{
					WriteFile( i, FILE_OVERWRITE );
					flag = ON;
				}
				else
					WriteFile( i, FILE_APPEND );
			}
			else
			{
				Message( "IuWFNg " + ObjName(i) + "\n"+
					 "ɂ́Aʂ݂Ȃ̂ŃZ[u܂B" );
			}
			ObjEdit( i, FALSE );
		}
	}
}

//
//	AgZ[u֐
//
function _SaveAtr( filename, savefile )
{
	var	i, num;
	var	flag = OFF;
	var	temp1, temp2;
	var	sel1, sel2;

	sel1 = Select();
	SelectAll( TRUE );
	sel2 = Select();
	PolyInvisible( FALSE );
	temp2 = fullpath(MakeFile(filename,".atr"));
	savefile = fullpath( MakeFile( savefile, ".atr" ));
	num = Attrs();
	for( i = 0; i< num; i++ )
	{
		if( AttrFile(i) != "" )
			temp1 = toupper( fullpath(MakeFile( AttrFile(i), ".atr")));
		else
			temp1 = "";
		if(( temp1 == toupper(temp2) ) | ( temp1 == "" ))
		{
			if( flag == OFF )
				AttrWriteFile( savefile, i, FILE_OVERWRITE );
			else
				AttrWriteFile( savefile, i, FILE_APPEND );
			flag = ON;
		}
		else
		{
			SelectAttr( i, TRUE, SELECT_UPDATE );
			if( SelectPolygons() != 0 )
			if( flag == OFF )
				AttrWriteFile( savefile, i, FILE_OVERWRITE );
			else
				AttrWriteFile( savefile, i, FILE_APPEND );
			flag = ON;
		}
	}
	Select( sel2 );
	PolyInvisible( invisible_flag );
	Select( sel1 );
}

//
//	VK쐬
//
function NewData()
{
	var	i, uv[2][2];
	var	flag = OFF;

	for( i = 0; i< Objects();i++ )
	{
		if( ObjEdit( i ))
		{
			flag = TRUE;
			break;
		}
	}
	if( flag )
	{
		Warning();
		DlogOpen( "", 1, "ݾ " ,""," ͂ " );
		DlogMessage( 0, "f[^ύXĂ܂Bۑ܂H" );
		i = DlogWait();
		if( i == 0 )
			return;
		else if(( i == 2 ) | ( i == RET ))
			SaveAll();
	}
	PolyInvisible( FALSE );
	SelectAll( TRUE, SELECT_UPDATE );
	if( SelectPolygons != 0 )
		PolyDelete();
	while( Objects() > 0 )
		ObjDelete( 0 );
	while( Attrs() > 0 )
		AttrDelete( 0 );
	ObjAppend( default_objname, default_filename );
	AttrAppend( default_atrname, default_atrcode );
	AttrFile( 0, default_atrfile );
	if( EXPERT != TRUE )
	{
		AttrMap( 0, TRUE );
		AttrMapFile( 0, MAPPINGFILE );
		uv[0] = {0,0};
		uv[1] = {MAPWIND-1, MAPWIND-1};
		SetAttrMapWind( 0, uv[0], uv[1] );
		uv[0] = {0,0};
		uv[1] = {UVMAX-1, UVMAX-1};
		SetAttrMapSize( 0, uv[0], uv[1] );
	}
	UpdateObject();
	UpdateAttribute();
	AllInit();
	Polygon();
}

function private _Load( atr_flag )
{
	var	filename, i, j, k, temp, temp2, flag = OFF;
	var	key, sel1, sel2, temp_sel, old_max, deleteflag[MAXOBJECT];

	filename = GetFile( "f[^[h", "", "suf" );
	if( typeof( filename ) == BOOLEAN )
		return;
	if( access( filename ) == FALSE )
	{
		Warning();
		Message( "t@C݂܂" );
		return FALSE;
	}

	temp = fullpath( filename );
	for( i = 0; i< Objects(); i++ )
	{
		temp2 = fullpath( ObjFile( i ));
		if( toupper(temp2) == toupper(temp) )
		{
			flag = TRUE;
			break;
		}
	}
	if( flag == TRUE )
	{
		flag = FALSE;
		for( i = 0; i< Objects(); i++ )
		{
			if( toupper(temp) == toupper( fullpath(ObjFile(i))))
			{
				if( ObjEdit(i) == TRUE )
				{
					flag = TRUE;
					break;
				}
			}
		}
		if( flag == TRUE )
		{
			Warning();
			DlogOpen( "", 2 , "", "͂" );
			DlogMessage( 0, "t@C͂łɓǂݍ܂Ă܂B" );
			DlogMessage( 1, "ҏW̃f[^j܂H" );
			key = DlogWait();
			if( key == 0 )
				return FALSE;
		}
		SelectAll( TRUE );
		sel2 = Select();
		PolyInvisible( FALSE );
		i = 0;
		while( i < Objects() )
		{
			if( toupper( temp) == toupper( fullpath( ObjFile(i))))
			{
				SelectObj( i, TRUE, SELECT_UPDATE );
				temp_sel = Select();
				Select( sel2 );
				PolyDelete( temp_sel );
				sel2 = Select();
				ObjDelete( i );
			}
			else
				i++;
		}
		Select( sel2 );
		PolyInvisible( invisible_flag );
	}
	flag = FALSE;
	old_max = Objects();
	j = 0;
	ReadFile( temp, OBJ_CREATE );
	for( i = old_max; i< Objects(); i++ )
	{
		k = ObjSearch( ObjName( i ));
		if(( k<old_max ) & ( k >= 0 ))
		{
			DlogOpen( "f[^̏㏑mF", 3, "ǂݍݒ~", "f[^j", "VKf[^j" );
			DlogMessage( 0, "ǂݍ݃t@C "+temp );
			DlogMessage( 1, "ɕҏW̃IuWFNg "+ObjName( i ) );
			DlogMessage( 2, "Ɠ̃IuWFNg݂܂Bǂ܂" );
			key = DlogWait();
			if( key == 0 )
			{
				PolyDelete();
				return FALSE;
			}
			else if( key == 1 )
			{
				deleteflag[j] = k;
				j++;
			}
			else
			{
				deleteflag[j] = i;
				j++;
			}
		}
	}
	sel1 = Select();
	for( k = 0; k< j; k++ )
	{
		temp = 0;
		for( i = 0; i< j; i++ )
		{
			if( deleteflag[temp] < deleteflag[i] )
				temp = i;
		}
		SelectObj( deleteflag[temp], TRUE, SELECT_UPDATE );
		temp_sel = Select();
		Select( sel1 );
		PolyDelete( temp_sel );
		sel1 = Select();
		ObjDelete( deleteflag[temp] );
		deleteflag[temp] = -1;
	}
	if( atr_flag == TRUE )
	{
		filename = MakeFile( substr( filename, ( !filename - 4 )), ".atr" );
		if( access( filename ))
			AttrReadFile( filename );
	}
	temp = Objects() -1;
	ObjCurrent( temp );
	UpdateObject();
	UpdateAttribute();
	Update( CLEAR );

}

function Close()
{
	var	filename, i, flag = FALSE;
	var	sel1, sel2;

	filename = toupper( fullpath( ObjFile( ObjCurrent())));
	for( i = 0; i< Objects();i++ )
	{
		if( filename == toupper( fullpath( ObjFile( i ))))
		{
			if( ObjEdit( i ))
			{
				flag = TRUE;
				break;
			}
		}
	}
	if( flag )
	{
		Warning();
		DlogOpen( "", 1,"ݾ ",""," ͂ " );
		DlogMessage( 0, "f[^ύXĂ܂Bۑ܂H" );
		i = DlogWait();
		if( i == 0 )
			return;
		else if( ( i == 2 )| (i == RET ))
		{
			_SaveSuf( filename, filename, FALSE );
			filename = substr( filename, ( !filename -4 ));
			_SaveAtr( filename, filename );
		}
	}
	sel1 = Select();
	SelectAll( TRUE );
	sel2 = Select();
	PolyInvisible( FALSE );
	i = 0;
	while( i < Objects())
	{
		if( filename == toupper( fullpath( ObjFile( i ))))
		{
			SelectObj( i, TRUE, SELECT_UPDATE );
			PolyDelete();
			ObjDelete( i );
		}
		else
			i++;
	}
	if( Objects() == 0 )
		Quit();
	else
	{
		Select( sel2 );
		PolyInvisible( invisible_flag );
		Select( sel1 );
		UpdateObject();
		Update( CLEAR );
	}
}

function _Save( atr_flag )
{
	var	sel1, sel2, temp;

	sel1 = Select();
	SelectAll( TRUE );
	sel2 = Select();
	PolyInvisible( FALSE );
	temp = ObjFile( ObjCurrent());
	_SaveSuf( temp, temp, FALSE );
	if( atr_flag == TRUE )
	{
		temp = substr( temp, (!temp - 4));
		_SaveAtr( temp, temp );
	}
	Select( sel2 );
	PolyInvisible( invisible_flag );
	Select( sel1 );
	UpdateObject();
}

function _Saveas( atr_flag )
{
	var	sel1, sel2, temp, filename;

	sel1 = Select();
	SelectAll( TRUE );
	sel2 = Select();
	PolyInvisible( FALSE );
	temp = ObjFile( ObjCurrent());
	filename = GetFile( "f[^Z[u", temp, "suf" );
	if( typeof( filename ) == BOOLEAN )
		return;
	if( atr_flag == TRUE )
	{
		_SaveSuf( temp, filename, TRUE );
		temp = substr( temp, (!temp - 4));
		filename = substr( filename, (!filename - 4));
		_SaveAtr( temp, filename );
	}
	else
		_SaveSuf( temp, filename, FALSE );
	Select( sel2 );
	PolyInvisible( invisible_flag );
	Select( sel1 );
	UpdateObject();
}

function _SaveAll( atr_flag )
{
	var const	maxfilenumber = 64;
	var	i, j, k=0, num;
	var	sel1, sel2;
	var	temp, filename[maxfilenumber];
	var	flag;

	num = Objects();
	for( i = 0; i< num ; i++ )
	{
		if( ObjEdit( i ) == TRUE )
		{
			temp = ObjFile( i );
			flag = TRUE;
			for( j= 0; j< k; j++ )
			{
				if( filename[j] == temp )
					flag = FALSE;
			}
			if( flag == TRUE )
			{
				filename[k] = temp;
				k++;
			}
		}
	}

	sel1 = Select();
	SelectAll( TRUE );
	sel2 = Select();
	PolyInvisible( FALSE );
	for( i = 0; i< k; i++ )
	{
		_SaveSuf( filename[i], filename[i], FALSE );
		if( atr_flag == TRUE )
		{
			temp = substr( filename[i], (!filename[i] - 4));
			_SaveAtr( temp, temp );
		}
	}
	Select( sel2 );
	PolyInvisible( invisible_flag );
	Select( sel1 );
	UpdateObject();
	return TRUE;
}

//
//	qvZX
//
function Shell()
	Child( getenv( "COMSPEC" ) );

//
//	I
//
function QuitModel()
{
	var	i;
	var	flag = OFF, return_flag = TRUE;

	for( i = 0; i< Objects();i++ )
	{
		if( ObjEdit( i ))
		{
			flag = TRUE;
			break;
		}
	}
	if( flag )
	{
		Warning();
		DlogOpen( "", 1,"ݾ ",""," ͂ " );
		DlogMessage( 0, "f[^ύXĂ܂Bۑ܂H" );
		i = DlogWait();
		if( i == 0 )
			return_flag =  FALSE;
		else if(( i == 2 ) | ( i == RET ))
		{
			if( EXPERT != TRUE )
				return_flag = _SaveAll( TRUE );
			else
				return_flag = _SaveAll( FALSE );
		}
	}
	if( return_flag == TRUE )
	{
		Quit();
		return TRUE;
	}
	else
		return FALSE;
}

function LoadAtr()
{
	var	filename, temp;
	var	old_max, i, j, k, key;
	var	copyflag[MAXATTR], deleteflag[MAXATTR];

	filename = GetFile( "f[^[h", "", "atr" );
	if( typeof( filename ) == BOOLEAN )
		return;
	temp = fullpath( filename );
	if( access( filename ) == FALSE )
	{
		Warning();
		Message( "t@C݂܂" );
		return FALSE;
	}

	old_max = Attrs();
	AttrReadFile( temp, ATTR_CREATE );
	for( i = old_max; i< Attrs(); i++ )
	{
		k = AttrSearch( AttrName( i ));
		if(( k<old_max ) & ( k >= 0 ))
		{
			if( AttrFile( k ) == "" )
			{
				copyflag[i] = k;
				deleteflag[i] = k;
			}
			else
			{
				DlogOpen( "f[^̏㏑mF", 3, "ǂݍݒ~", "f[^j", "VKf[^j" );
				DlogMessage( 0, "ǂݍ݃t@C "+temp );
				DlogMessage( 1, "ɕҏW̃Agr[g "+AttrName( i ) );
				DlogMessage( 2, "Ɠ̃Agr[g݂܂Bǂ܂" );
				key = DlogWait();
				if( key == 0 )
				{
					while( old_max < Attrs() )
						AttrDelete( old_max );
					return FALSE;
				}
				else if( key == 1 )
				{
					copyflag[i] = k;
					deleteflag[i] = k;
				}
				else
				{
					copyflag[i] = k;
					deleteflag[i] = i;
				}
			}
		}
		else
		{
			copyflag[i] = i;
			deleteflag[i] = i;
		}
	}
	for( i = old_max; i< Attrs(); i++ )
	{
		if( copyflag[i] != i )
		{
			if( deleteflag[i] == i )
			{
				AttrFile( copyflag[i], temp );
				AttrCopy( copyflag[i], i );
			}
			else
			{
				AttrFile( copyflag[i], temp );
				AttrCopy( i, copyflag[i] );
			}
		}
		if( copyflag[i] != i )
			AttrName( i, "" );
	}
	j = 0;
	while( j < Attrs() )
	{
		if( AttrName( j ) == "" )
			AttrDelete( j );
		else
			j++;
	}
	UpdateAttribute();
	Update( OVERWRITE );
}

function _SaveAtrforExpert( file, savefile )
{
	var	i, org, savename, temp, flag = FALSE;

	org = toupper(fullpath( file ));
	savename = fullpath( savefile );
	for( i = 0; i< Attrs(); i++ )
	{
		temp = toupper(fullpath(AttrFile( i )));
		if( temp == org )
		{
			AttrFile( i , savename );
			if( flag == TRUE )
				AttrWriteFile( savename, i, FILE_APPEND );
			else
			{
				AttrWriteFile( savename, i, FILE_OVERWRITE );
				flag = TRUE;
			}
		}
	}
}

function Load()
	_Load( TRUE );

function LoadSuf()
	_Load( FALSE );

function Save()
	_Save( TRUE );

function SaveSuf()
	_Save( FALSE );

function Saveas()
	_Saveas( TRUE );

function SaveasSuf()
	_Saveas( FALSE );

function SaveAll()
	_SaveAll( TRUE );

function SaveAllSuf()
	_SaveAll( FALSE );

function SaveasAtr()
{
	var	temp, filename;

	temp = AttrFile( AttrCurrent());
	filename = GetFile( "f[^Z[u", temp, "atr" );
	if( typeof( filename ) == BOOLEAN )
		return;
	_SaveAtrforExpert( temp, filename );
}

function SaveAtr()
{
	var	temp;
	temp = AttrFile( AttrCurrent() );
	if( temp == "" )
	{
		Warning();
		Message( "t@Cݒ肳ĂȂ̂ŁA\n"+
			 "Z[uł܂łB" );
		return;
	}
	_SaveAtrforExpert( temp, temp );
}

//
//	t@Cj[
//
if( MACHINE == "WINDOWS" )
{
	if( EXPERT != TRUE )
	{
		MenuPosition(
				Menu( "̧(&F)",
				"VK쐬@           ",	NewData,
				"---------------------",	SEPARATE_MENU,
				"GENIE߰VK쐬",	NewDataforGENIE,
				"---------------------",	SEPARATE_MENU,
				"J...              ",	Load,
				"               ",	Close,
				"---------------------",	SEPARATE_MENU,
				"Ҷ޻޲ްJ...",	LoadMecha,
				"---------------------",	SEPARATE_MENU,
				"㏑ۑ           ",	Save,
				"Otĕۑ...  ",	Saveas,
				"ׂĕۑ           ",	SaveAll,
				"---------------------",	SEPARATE_MENU,
				"GENIE߰o^    ",	InstallParts,
				"---------------------",	SEPARATE_MENU,
				"I    @           ",	QuitModel
			), Menu_file
		);
	}
	else
	{
		MenuPosition(
			Menu( "̧(&F)",
				"VK쐬@@           ",	NewData,
				"-----------------------",	SEPARATE_MENU,
				"GENIE߰VK쐬",	NewDataforGENIE,
				"---------------------",	SEPARATE_MENU,
				"޼ުĂJ...      ",	LoadSuf,
				"޼ުĂ       ",	Close,
				"-----------------------",	SEPARATE_MENU,
				"Ҷ޻޲ްJ...  ",	LoadMecha,
				"-----------------------",	SEPARATE_MENU,
				"ޭĂJ...      ",	LoadAtr,MENU_ENABLE,
				"-----------------------",	SEPARATE_MENU,
				"޼ުĂۑ@@@@ ",	SaveSuf,MENU_ENABLE,
				"޼ުĂʖŕۑ...",	SaveasSuf,MENU_ENABLE,
				"޼ުĂSĕۑ     ",	SaveAllSuf,MENU_ENABLE,
				"-----------------------",	SEPARATE_MENU,
				"ޭĂۑ         ",	SaveAtr,MENU_ENABLE,
				"ޭĂʖŕۑ...",	SaveasAtr,MENU_ENABLE,
//				"ޭĂSĕۑ     ",	SaveAllAtr,MENU_ENABLE,
				"-----------------------",	SEPARATE_MENU,
				"GENIE߰o^      ",	InstallParts,
				"-----------------------",	SEPARATE_MENU,
				"I    @          @ ",	QuitModel
			), Menu_file
		);
	}
}
else
{
		MenuPosition(
			Menu( "̧(&F)",
				"VK쐬@@           ",	NewData,
				"-----------------------",	SEPARATE_MENU,
				"޼ުĂJ...      ",	LoadSuf,
				"޼ުĂ       ",	Close,
				"-----------------------",	SEPARATE_MENU,
				"ޭĂJ...      ",	LoadAtr,MENU_ENABLE,
				"-----------------------",	SEPARATE_MENU,
				"޼ުĂۑ@@@@ ",	SaveSuf,MENU_ENABLE,
				"޼ުĂʖŕۑ...",	SaveasSuf,MENU_ENABLE,
				"޼ުĂSĕۑ     ",	SaveAllSuf,MENU_ENABLE,
				"-----------------------",	SEPARATE_MENU,
				"ޭĂۑ         ",	SaveAtr,MENU_ENABLE,
				"ޭĂʖŕۑ...",	SaveasAtr,MENU_ENABLE,
//				"ޭĂSĕۑ     ",	SaveAllAtr,MENU_ENABLE,
				"-----------------------",	SEPARATE_MENU,
				"qvZX@           ",	Shell,
				"-----------------------",	SEPARATE_MENU,
				"I    @          @ ",	QuitModel
			), Menu_file
		);
}
