/*  static char SccsId[] = "@(#)acdfile.h	1.4   6/13/95";
 *
 *		Copyright (c) KUBOTA Corporation,
 *		1994, 1995 All Rights Reserved
 *
 *  This software comprises unpublished confidential information of 
 *  KUBOTA Corp. and may not be used, copied or made available to anyone,
 *  except in accordance with the license under which it is furnished.
 */

#ifndef _ACD_FILE_HEADER__
#define	_ACD_FILE_HEADER__

#include	"acfile.h"		/* Aurora Data file header */

/********************************************************************/

/* Color type definitions <color_type> */
#define ACD_COLOR_TYPE_YUV888		AC_COLOR_TYPE_YUV888
#define ACD_COLOR_TYPE_YUV844		AC_COLOR_TYPE_YUV844
#define ACD_COLOR_TYPE_RGB888		AC_COLOR_TYPE_RGB888
#define ACD_COLOR_TYPE_RGB555		AC_COLOR_TYPE_RGB555


/*******************
  for file image
 *******************/

/********************************************************************/
/* define type of file image structure */

typedef struct { /* 16 bytes */
/* Aurora tools characteristic structure member <16 bytes> */
	CARD16	display_mode;		/* 48..49 */
	CARD16	reserved1;		/* 50..51 */
	CARD16	reserved2;		/* 52..53 */
	CARD16	colortbl_cnt;		/* 54..55 */
	CARD32	colortbl_addr;		/* 56..59 */
	CARD32	colortbl_size;		/* 60..63 */
} fcolormaphdr_t;

typedef struct { /* 40 bytes */
	CARD8	color_type;		/*  0..0  */
	CARD8	reserved1;		/*  1..1  */
	CARD16	colormap_type;		/*  2..3  */
	CARD16	colormap_id;		/*  4..5  */
	CARD8	reserved2[16];		/*  6..21 */
	CARD16	ncolors;		/* 22..23 */
	CARD16	C_offset;		/* 24..25 */
	CARD16	I_offset;		/* 26..27 */
	CARD16	C_size;			/* 28..29 */
	CARD16	I_size;			/* 30..31 */
	CARD32	colormap_addr;		/* 32..35 */
	CARD32	colormap_size;		/* 36..39 */
} fcolormaptbl_t;

/********************************************************************/

/* define type of memory image structure */

typedef struct { 
/* Aurora tools characteristic structure member */
	CARD16	display_mode;
	CARD16	reserved1;
	CARD16	reserved2;
	CARD16	colortbl_cnt;
	void	*colortbl_addr;
	CARD32	colortbl_size;
} colormaphdr_t;

typedef struct { 
	CARD8	color_type;
	CARD8	reserved1;
	CARD16	colormap_type;
	CARD16	colormap_id;
	CARD8	reserved2[16];
	CARD16	ncolors;
	CARD16	C_offset;
	CARD16	I_offset;
	CARD16	C_size;
	CARD16	I_size;
	void	*colormap_addr;
	CARD32	colormap_size;
} colormaptbl_t;


#endif	/* _ACD_FILE_HEADER__ */

