/*
 * service.c
 */
#include <agl.h>
#include <common.h>
#include "spec.h"
#include "service.h"
#include "vardecl.h"
#include "psgdef.h"
#include "math.h"

#ifndef LOCAL
#define LOCAL
#endif

#define another(x) ((x == PLAYER1) ? PLAYER2 : PLAYER1)
#define FIELD_MIN (-GroundEdgeLoc)
#define FIELD_MAX (GroundEdgeLoc)

/*
========================================
  Oi
========================================
*/
void
S_Forward(int which)
{
  register machine *mp;
  float x, y;
  float acc;
  int vel;

  mp = &Machine[which];
  x = mp->vector.x;
  y = mp->vector.y;
  vel = GETA_RAD * sqrt(x * x + y * y);
  if (vel >= TABLESIZ)		/* *** */
    vel = TABLESIZ - 1;
  acc = mp->type->AccTable[vel];
  mp->vector.x += acc * sintbl[mp->direct];
  mp->vector.y -= acc * costbl[mp->direct];

  /* xČvZ */
  x = mp->vector.x;
  y = mp->vector.y;
  vel = GETA_RAD * sqrt(x * x + y * y);
  switch (mp->fbflag) {
  case FB_STOP:
    mp->fbflag = FB_FORWARD;
    break;
  case FB_FORWARD:
    break;
  case FB_BACKWARD:
    if (vel == 0) {
      mp->vector.x = mp->vector.y = 0.0;
      mp->fbflag = FB_STOP;
    }
    break;
  }
}

/*
========================================
  
========================================
*/
void
S_Backward(int which)
{
  register machine *mp;
  float     x, y;
  float     acc;
  int       vel;
  int       NegFlagX,NegFlagY;
  int       NegFlagX2,NegFlagY2;

  mp = &Machine[which];
  
  x = mp->vector.x;
  y = mp->vector.y;
  /* ݂̃xN^[̕E */
  if (x < 0)
    NegFlagX = -1;
  else
    NegFlagX = 1;
  if (y < 0)
    NegFlagY = -1;
  else
    NegFlagY = 1;

  vel = GETA_RAD * sqrt(x * x + y * y);
  if (vel >= TABLESIZ)		/*  */
    vel = TABLESIZ - 1;
  acc = mp->type->BrakeTable[vel];
  mp->vector.x -= acc * sintbl[mp->direct] * mp->fbflag;
  mp->vector.y += acc * costbl[mp->direct] * mp->fbflag;

  /* xČvZ */
  x = mp->vector.x;
  y = mp->vector.y;
  /* ̃xN^[̕E */
  if (x < 0)
    NegFlagX2 = -1;
  else
    NegFlagX2 = 1;
  if (y < 0)
    NegFlagY2 = -1;
  else
    NegFlagY2 = 1;
  /* AɃxN^[̕]Ă悤Ȃ */
  /* obN悤ƂĂ̂őxOƂĈ */
  if(NegFlagX != NegFlagX2 || NegFlagY != NegFlagY2){
    vel = 0;
  } else {
    vel = GETA_RAD * sqrt(x * x + y * y);
  }
  switch (mp->fbflag) {
  case FB_STOP:
//    mp->fbflag = FB_BACKWARD;
    break;
  case FB_BACKWARD:
  case FB_FORWARD:
    if (vel == 0) {
      mp->vector.x = mp->vector.y = 0.0;
      mp->fbflag = FB_STOP;
    }
    break;
  }
}

/*
========================================
  EɋȂ
========================================
*/
void
S_TurnRight(int which)
{
  register machine *mp;
  int angle;
  float x, y, t;

  mp = &Machine[which];
  /* ~Ȃnh͐؂Ȃ */
  if (mp->fbflag == FB_STOP)
    return;

  angle = mp->type->Handling * mp->fbflag;

  mp->direct -= angle;
  if (mp->direct < 0)
    mp->direct += 3600;
  mp->direct %= 3600;

  x = mp->vector.x;
  y = mp->vector.y;
  if (x > MAX_RAD)
    x = MAX_RAD;
  if (y > MAX_RAD)
    y = MAX_RAD;
  t = sqrt(x * x + y * y);
  mp->vector.x = t * sintbl[mp->direct] * mp->fbflag;
  mp->vector.y = -t * costbl[mp->direct] * mp->fbflag;
}

/*
========================================
  ɋȂ
========================================
*/
void
S_TurnLeft(int which)
{
  register machine *mp;
  int angle;
  float x, y, t;
  direct_t dir;
  short fb;

  mp = &Machine[which];
  /* ~Ȃnh͐؂Ȃ */
  if (mp->fbflag == FB_STOP)
    return;

  angle = mp->type->Handling * mp->fbflag;

  mp->direct += angle;
  mp->direct %= 3600;

  x = mp->vector.x;
  y = mp->vector.y;
  if (x > MAX_RAD)
    x = MAX_RAD;
  if (y > MAX_RAD)
    y = MAX_RAD;
  t = sqrt(x * x + y * y);
  mp->vector.x = t * sintbl[mp->direct] * mp->fbflag;
  mp->vector.y = -t * costbl[mp->direct] * mp->fbflag;
}

/*
========================================
  ݂̑xԂ
========================================
*/
accel_t
S_GetSpeed(int which)
{
  register machine *mp;

  mp = &Machine[which];
  return sqrt(mp->vector.x * mp->vector.x + mp->vector.y * mp->vector.y)
            * mp->fbflag;
}

/*
----------------------------------------
  pxɑ΂Ă̒[܂ł̋
----------------------------------------
*/
LOCAL distance
__CheckDist(direct_t angle,float x, float y)
{
  float l1,l2;

  /* ͈͊OȂ␳ */
  angle %= 3600;
  /* XOxPʂ̊px̏ꍇZŏ\Ȃ̂œʏ */
  if( angle == 0 || angle == 900 || angle == 1800 || angle == 2700 ){
    switch(angle){
      case 0:
        l1 = FIELD_MIN - y;
        break;
      case 900:
        l1 = FIELD_MAX - x;
        break;
      case 1800:
        l1 = FIELD_MAX - y;
        break;
      case 2700:
        l1 = FIELD_MIN - x;
        break;
    }
  }
  else{
    l1 = -y;
    y = x;
    x = l1;
    if(angle > 0 && angle < 1800){
      if(angle < 900){
        l1= (FIELD_MAX - x) / costbl[angle];
        l2= (FIELD_MAX - y) / sintbl[angle];
      }
      else{
        l1= (FIELD_MIN - x) / costbl[angle];
        l2= (FIELD_MAX - y) / sintbl[angle];
      }
    }
    else{
      if(angle < 2700){
        l1= (FIELD_MIN - x) / costbl[angle];
        l2= (FIELD_MIN - y) / sintbl[angle];
      }
      else{
        l1= (FIELD_MAX - x) / costbl[angle];
        l2= (FIELD_MIN - y) / sintbl[angle];
      }
    }
    l1 = abs(l1);
    l2 = abs(l2);
    if(l1>l2){
      l1 = l2;
    }
  }
  return abs(l1);
}

/*
========================================
isɂtB[h̒[܂ł̋߂
========================================
*/
QuadDist *
S_CheckDist(int which)
{
  register machine *mp;
  distance dDist;
  direct_t tDirect;
  static QuadDist qQuadDist;
  float x, y;

  mp = &Machine[which];
  tDirect = mp->direct;
  x = Locate[which][LX];
  y = Locate[which][LY];
  /* O */
  qQuadDist.dFrontDist = __CheckDist(tDirect,x,y);
  /*  ( 180] ) */
  qQuadDist.dBackDist  = __CheckDist(tDirect + 1800,x,y);
  /*  (  90] ) */
  qQuadDist.dLeftDist  = __CheckDist(tDirect +  900,x,y);
  /* E ( 270] ) */
  qQuadDist.dRightDist = __CheckDist(tDirect + 2700,x,y);

  return &qQuadDist;
}

/*
========================================
  ̂wW߂
========================================
*/
float
S_CheckX(int which)
{
  return Locate[which][LX];
}

/*
========================================
  ̂xW߂
========================================
*/
float
S_CheckY(int which)
{
  return Locate[which][LY];
}

/*
========================================
  ̊px߂
========================================
*/
direct_t
S_CheckDir(int which)
{
  return Machine[which].direct;
}

/*
========================================
  Ƃ̋߂
  肪A180ɂꍇ
  ́A-1ɂȂB
========================================
*/
distance
S_CalcEnemyDist(int which)
{
  float myX,myY;
  float anX,anY;
  direct_t tEnemyDir;
  
  myX = Locate[which][LX];
  myY = Locate[which][LY];
  anX = Locate[another(which)][LX];
  anY = Locate[another(which)][LY];
  tEnemyDir = PointMakeDir(myX,myY,anX,anY);
  tEnemyDir -= S_CheckDir(which);
  if (tEnemyDir < 0)
    tEnemyDir += 3600;
  if(tEnemyDir > 900 && tEnemyDir < 2700){
    return (distance) -1;
  }
  myX -= anX;
  myY -= anY;
  return sqrt(myX * myX + myY * myY);
}

/*
========================================
  ƎƂ̊px߂
  肪ɂꍇ
  px́A-1ɂȂB
========================================
*/
direct_t
S_SearchEnemy(int which)
{
  float myX,myY;
  float anX,anY;
  direct_t tEnemyDir;
  
  myX = Locate[which][LX];
  myY = Locate[which][LY];
  anX = Locate[another(which)][LX];
  anY = Locate[another(which)][LY];
  tEnemyDir = PointMakeDir(myX,myY,anX,anY);
  tEnemyDir -= S_CheckDir(which);
  if(tEnemyDir < 0)
    tEnemyDir += 3600;
  if(tEnemyDir > 900 && tEnemyDir < 2700){
  	return (direct_t) -1;
  }
  return tEnemyDir;
}
